﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TouchPanelControls_CS_NET5;

namespace TouchPanelControls_CS_NET5_Demo
{
	enum TestEnum
	{
		A, B, CDEFGHIJKLMN
	}

	public partial class Form1 : Form
	{
		List<ITableLayoutControl> ConList = new List<ITableLayoutControl>();

		public Form1()
		{
			InitializeComponent();
			NumericUpDown_TableLayout nudVal0 = new NumericUpDown_TableLayout("val0", tlpTest0, 0, 0);
			NumericUpDown_TableLayout nudVal1 = new NumericUpDown_TableLayout("val1", tlpTest0, 0, 1);
			nudVal0.ValueChanged = (sender) =>
			{
				nudVal1.Value = nudVal0.Value;
			};
			nudVal1.ValueChanged = (sender) =>
			{
				nudVal0.Value_Noreport = nudVal1.Value;

			};

			NumericUpDown_TableLayout nudVal2 = new NumericUpDown_TableLayout("val2", tlpTest0, 0, 2)
			{
				DecimalPlace = 2,
				Increment = 0.01,
				Maximum = 5,
				Minimum = -5,
				ValueChanged = (sender) => { tbMonitor0.Text = $"nudVal2:{(sender as NumericUpDown_TableLayout).Value:f2}"; }
			};
			nudVal2.Value = 1;

			ComboBox_TableLayout<TestEnum> cbEnum0 = new ComboBox_TableLayout<TestEnum>("cbEnum", tlpTest0, 0, 3);
			ComboBox_TableLayout<string> cbEnum1 = new ComboBox_TableLayout<string>("cbEnum", tlpTest0, 1, 3, Enum.GetNames(typeof(TestEnum)));

			SelectButton_TableLayout<TestEnum> selector0 = new SelectButton_TableLayout<TestEnum>("selector0", tlpTest0, 0, 4);
			selector0.Value = 0;
			SelectButton_TableLayout<string> selector1 = new SelectButton_TableLayout<string>("selector1", tlpTest0, 1, 4, Enum.GetNames(typeof(TestEnum)));
			selector1.Value =20;

			ConList.Add(nudVal0);
			ConList.Add(nudVal1);
			ConList.Add(nudVal2);
			ConList.Add(cbEnum0);
			ConList.Add(cbEnum1);
			ConList.Add(selector0);
			ConList.Add(selector1);
			foreach (var c in ConList)
				c.GotFocus = FocusChanged;

			ITableLayoutControl.AdjustFontSize(nudVal0, 6, ConList);
			cbEnum1.AdjustListWidth();
			selector1.AdjustButtonFonts();

			SwitchButton sb = new SwitchButton(button1) { FrontTextTrue = "ON", FrontTextFalse = "OFF" };
			sb.ValueChanged = SwitchButton_ValueChanged;
			sb.Value = true;

			int max = 3;
			for (int i = -20; i < 20; ++i)
				tbMonitor0.Text += (i % max).ToString() + ",";
		}
		void FocusChanged(object sender)
		{
			ITableLayoutControl con = sender as ITableLayoutControl;
			tbFocus.Text = $"Focus: {con.LabelText}";
		}
		void SwitchButton_ValueChanged(object sender)
		{
			SwitchButton sb = sender as SwitchButton;
			tbMonitor1.Text = $"SwitchButton:{sb.Value}";
		}

	}

}
